<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- howtos.qdoc -->
  <title>How-tos | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >How-tos</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="custom-modules.html" />
  <link rel="next" href="reference.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="custom-modules.html">Custom Modules and Items</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="reference.html">Reference</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#how-do-i-build-a-qt-based-project">How do I build a Qt-based project?</a></li>
<li class="level1"><a href="#how-do-i-make-my-app-build-against-my-library">How do I make my app build against my library?</a></li>
<li class="level2"><a href="#choosing-between-dynamic-and-statically-built-qt-projects">Choosing Between Dynamic and Statically-built Qt Projects</a></li>
<li class="level1"><a href="#how-do-i-use-precompiled-headers">How do I use precompiled headers?</a></li>
<li class="level1"><a href="#how-do-i-make-sure-my-generated-sources-are-getting-compiled">How do I make sure my generated sources are getting compiled?</a></li>
<li class="level1"><a href="#how-do-i-run-my-autotests">How do I run my autotests?</a></li>
<li class="level1"><a href="#how-do-i-use-ccache">How do I use ccache?</a></li>
<li class="level1"><a href="#how-do-i-create-a-module-for-a-third-party-library">How do I create a module for a third-party library?</a></li>
<li class="level1"><a href="#how-do-i-create-application-bundles-and-frameworks-on-ios-macos-tvos-and-watchos">How do I create application bundles and frameworks on iOS, macOS, tvOS, and watchOS?</a></li>
<li class="level1"><a href="#how-do-i-build-against-libraries-that-provide-pkg-config-files">How do I build against libraries that provide pkg-config files?</a></li>
<li class="level1"><a href="#how-do-i-apply-c-c-preprocessor-macros-to-only-a-subset-of-the-files-in-my-product">How do I apply C/C++ preprocessor macros to only a subset of the files in my product?</a></li>
<li class="level1"><a href="#how-do-i-make-the-state-of-my-git-repository-available-to-my-source-files">How do I make the state of my Git repository available to my source files?</a></li>
<li class="level1"><a href="#how-do-i-limit-the-number-of-concurrent-jobs-for-the-linker-only">How do I limit the number of concurrent jobs for the linker only?</a></li>
<li class="level1"><a href="#how-do-i-add-qml-files-to-a-project">How do I add QML files to a project?</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">How-tos</h1>
<span class="subtitle"></span>
<!-- $$$howtos.html-description -->
<div class="descr"> <a name="details"></a>
<p>This page provides concrete instructions for common scenarios.</p>
<ul>
<li><a href="howtos.html#how-do-i-build-a-qt-based-project">How do I build a Qt-based project?</a></li>
<li><a href="howtos.html#how-do-i-make-my-app-build-against-my-library">How do I make my app build against my library?</a></li>
<li><a href="howtos.html#how-do-i-use-precompiled-headers">How do I use precompiled headers?</a></li>
<li><a href="howtos.html#how-do-i-make-sure-my-generated-sources-are-getting-compiled">How do I make sure my generated sources are getting compiled?</a></li>
<li><a href="howtos.html#how-do-i-run-my-autotests">How do I run my autotests?</a></li>
<li><a href="howtos.html#how-do-i-use-ccache">How do I use ccache?</a></li>
<li><a href="howtos.html#how-do-i-create-a-module-for-a-third-party-library">How do I create a module for a third-party library?</a></li>
<li><a href="howtos.html#how-do-i-build-against-libraries-that-provide-pkg-config-files">How do I build against libraries that provide pkg-config files?</a></li>
<li><a href="howtos.html#how-do-i-create-application-bundles-and-frameworks-on-ios-macos-tvos-and-watchos">How do I create application bundles and frameworks on iOS, macOS, tvOS, and watchOS?</a></li>
<li><a href="howtos.html#how-do-i-apply-c-c-preprocessor-macros-to-only-a-subset-of-the-files-in-my-product">How do I apply C/C++ preprocessor macros to only a subset of the files in my product?</a></li>
<li><a href="howtos.html#how-do-i-make-the-state-of-my-git-repository-available-to-my-source-files">How do I make the state of my Git repository available to my source files?</a></li>
<li><a href="howtos.html#how-do-i-limit-the-number-of-concurrent-jobs-for-the-linker-only">How do I limit the number of concurrent jobs for the linker only?</a></li>
<li><a href="howtos.html#how-do-i-add-qml-files-to-a-project">How do I add QML files to a project?</a></li>
</ul>
<a name="how-do-i-build-a-qt-based-project"></a>
<h2 id="how-do-i-build-a-qt-based-project">How do I build a Qt-based project?</h2>
<p>First of all, your project files need to declare <a href="qml-qbslanguageitems-depends.html">dependencies</a> on <a href="porting-to-qbs.html#qt">Qt</a> modules.</p>
<p>To build the project, you need a matching <i>profile</i>. The following commands set up and use a Qt-specific profile:</p>
<pre class="cpp">

  $ qbs setup<span class="operator">-</span>qt <span class="operator">/</span>usr<span class="operator">/</span>bin<span class="operator">/</span>qmake qt
  $ cd my_project
  $ qbs profile:qt

</pre>
<p>If you plan to use this profile a lot, consider making it the default one:</p>
<pre class="cpp">

  $ qbs config defaultProfile qt
  $ cd my_project
  $ qbs

</pre>
<p>See <a href="qt-versions.html">Managing Qt Versions</a> for more details.</p>
<p><b>Note: </b>These instructions are only relevant for building from the command line. If you use Qt Creator, profiles are set up automatically from the information in the Kit.</p><a name="how-do-i-make-my-app-build-against-my-library"></a>
<h2 id="how-do-i-make-my-app-build-against-my-library">How do I make my app build against my library?</h2>
<p>This is achieved by introducing a <i>dependency</i> between the two products using the <a href="qml-qbslanguageitems-depends.html">Depends</a> item. Here is a simple, but complete example:</p>
<pre class="cpp">

  Project {
      CppApplication {
          name : <span class="string">&quot;the-app&quot;</span>
          files : <span class="operator">[</span> <span class="string">&quot;main.cpp&quot;</span> <span class="operator">]</span>
          Depends { name: <span class="string">&quot;the-lib&quot;</span> }
      }
      DynamicLibrary {
          name: <span class="string">&quot;the-lib&quot;</span>
          Depends { name: <span class="string">&quot;cpp&quot;</span> }
          files: <span class="operator">[</span>
              <span class="string">&quot;lib.cpp&quot;</span><span class="operator">,</span>
              <span class="string">&quot;lib.h&quot;</span><span class="operator">,</span>
          <span class="operator">]</span>
          Export {
              Depends { name: <span class="string">&quot;cpp&quot;</span> }
              cpp<span class="operator">.</span>includePaths: <span class="operator">[</span>product<span class="operator">.</span>sourceDirectory<span class="operator">]</span>
         }
      }
  }

</pre>
<p>The product <code>the-lib</code> is a dynamic library. It expects other products to build against it, and for that purpose, it exports an include path (via an <a href="qml-qbslanguageitems-export.html">Export</a> item), so that the source files in these products can include the library's header file.</p>
<p>The product <code>the-app</code> is an application that expresses its intent to link against <code>the-lib</code> by declaring a dependency on it. Now <code>main.cpp</code> can include <code>lib.h</code> (because of the exported include path) and the application binary will link against the library (because the linker <a href="qml-qbslanguageitems-rule.html">rule</a> in the <a href="qml-qbsmodules-cpp.html">cpp</a> module considers library dependencies as inputs).</p>
<p><b>Note: </b>In a non-trivial project, the two products would not be defined in the same file. Instead, you would put them into files of their own and use the <a href="qml-qbslanguageitems-project.html#references-prop">Project.references</a> property to pull them into the project. The product definitions would stay exactly the same. In particular, their location in the project tree is irrelevant to the relationship between them.</p><a name="choosing-between-dynamic-and-statically-built-qt-projects"></a>
<h3 id="choosing-between-dynamic-and-statically-built-qt-projects">Choosing Between Dynamic and Statically-built Qt Projects</h3>
<p>To build <code>&quot;the-lib&quot;</code> as either a dynamic or static library, depending on how Qt was built, you can use the following code:</p>
<pre class="cpp">

  Product {
      name: <span class="string">&quot;the-lib&quot;</span>
      type: <span class="type">Qt</span><span class="operator">.</span>core<span class="operator">.</span>staticBuild <span class="operator">?</span> <span class="string">&quot;staticlibrary&quot;</span> : <span class="string">&quot;dynamiclibrary&quot;</span>

      Depends { name: <span class="string">&quot;Qt.core&quot;</span> }
      <span class="comment">// ...</span>
  }

</pre>
<a name="how-do-i-use-precompiled-headers"></a>
<h2 id="how-do-i-use-precompiled-headers">How do I use precompiled headers?</h2>
<p>If you use a <a href="qml-qbslanguageitems-group.html">Group</a> item to add a precompiled header file to a product and mark it with the <a href="qml-qbsmodules-cpp.html#filetags-cpp">relevant file tag</a> (<code>c_pch_src</code>, <code>cpp_pch_src</code>, <code>objc_pch_src</code>, or <code>objcpp_pch_src</code>), it is used automatically.</p>
<p>Only one precompiled header is allowed per product and language.</p>
<p>For example:</p>
<pre class="cpp">

  CppApplication {
      name: <span class="string">&quot;the-app&quot;</span>
      files: <span class="operator">[</span><span class="string">&quot;main.cpp&quot;</span><span class="operator">]</span>

      Group {
          files: <span class="operator">[</span><span class="string">&quot;precompiled-header.pch&quot;</span><span class="operator">]</span>
          fileTags: <span class="operator">[</span><span class="string">&quot;cpp_pch_src&quot;</span><span class="operator">]</span>
      }
  }

</pre>
<a name="how-do-i-make-sure-my-generated-sources-are-getting-compiled"></a>
<h2 id="how-do-i-make-sure-my-generated-sources-are-getting-compiled">How do I make sure my generated sources are getting compiled?</h2>
<p>The rules in a Qbs project do not care whether its inputs are actual source files listed on the right-hand side of a <a href="qml-qbslanguageitems-product.html#files-prop">files</a> property or artifacts that were generated by another rule. For instance, the C++ compiler rule considers all input files of type &quot;cpp&quot;, no matter how they got into the product. The following example project demonstrates this. One of its source files exists in the repository, the other one is generated at build time. Both are getting compiled the same way.</p>
<p><b>Note: </b>Do not try to add the generated files to a <code>files</code> property. Declaring them as rule outputs is all that is needed to make Qbs know about them.</p><pre class="cpp">

  import qbs<span class="operator">.</span>TextFile
  CppApplication {
      files: <span class="operator">[</span><span class="string">&quot;impl.cpp&quot;</span><span class="operator">,</span> <span class="string">&quot;impl.h&quot;</span><span class="operator">]</span>
      cpp<span class="operator">.</span>includePaths: sourceDirectory
      Rule {
          multiplex: <span class="keyword">true</span>
          Artifact { filePath: <span class="string">&quot;main.cpp&quot;</span>; fileTags: <span class="string">&quot;cpp&quot;</span> }
          prepare: {
              var cmd <span class="operator">=</span> <span class="keyword">new</span> JavaScriptCommand();
              cmd<span class="operator">.</span>description <span class="operator">=</span> <span class="string">&quot;generating &quot;</span> <span class="operator">+</span> output<span class="operator">.</span>fileName;
              cmd<span class="operator">.</span>sourceCode <span class="operator">=</span> function() {
                  var f <span class="operator">=</span> <span class="keyword">new</span> TextFile(output<span class="operator">.</span>filePath<span class="operator">,</span> TextFile<span class="operator">.</span>WriteOnly);
                  f<span class="operator">.</span>writeLine(<span class="string">&quot;#include &lt;impl.h&gt;&quot;</span>);
                  f<span class="operator">.</span>writeLine(<span class="string">&quot;int main()&quot;</span>);
                  f<span class="operator">.</span>writeLine(<span class="string">&quot;{&quot;</span>);
                  f<span class="operator">.</span>writeLine(<span class="string">&quot;    return functionFromImpl();&quot;</span>);
                  f<span class="operator">.</span>writeLine(<span class="string">&quot;}&quot;</span>);
                  f<span class="operator">.</span>close();
              };
              <span class="keyword">return</span> cmd;
          }
      }
  }

</pre>
<a name="how-do-i-run-my-autotests"></a>
<h2 id="how-do-i-run-my-autotests">How do I run my autotests?</h2>
<p>There are two simple things you need to do in your project. Firstly, you mark your test executables as such. This is done by adding the tag <code>&quot;autotest&quot;</code> to the product type:</p>
<pre class="cpp">

  CppApplication {
      name: <span class="string">&quot;test1&quot;</span>
      type: base<span class="operator">.</span>concat(<span class="string">&quot;autotest&quot;</span>)
      <span class="comment">// ...</span>
  }

</pre>
<p>The second step is to instantiate an <a href="qml-qbsconvenienceitems-autotestrunner.html">AutotestRunner</a> product in your project:</p>
<pre class="cpp">

  Project {
      <span class="comment">// ...</span>
      AutotestRunner { name: <span class="string">&quot;run_my_tests&quot;</span> }
  }

</pre>
<p>Building an <a href="qml-qbsconvenienceitems-autotestrunner.html">AutotestRunner</a> product does not produce artifacts, but triggers execution of all applications whose products are tagged as autotests:</p>
<pre class="cpp">

  $ qbs <span class="operator">-</span>p run_my_tests
  test1: PASS
  test2: PASS
  test3: FAIL
  <span class="operator">.</span><span class="operator">.</span><span class="operator">.</span>

</pre>
<p>See the <a href="qml-qbsconvenienceitems-autotestrunner.html">AutotestRunner documentation</a> for how to fine-tune the behavior.</p>
<a name="how-do-i-use-ccache"></a>
<h2 id="how-do-i-use-ccache">How do I use ccache?</h2>
<p><a href="https://ccache.samba.org/">ccache</a> is a popular C/C++ compiler cache on Unix to speed up compiling the same content multiple times.</p>
<p>Qbs excels at tracking dependencies and avoiding needless recompilations, so for linear development of one project and configuration using ccache has little benefit. But if you switch between revisions of a project, or build the same project with different configurations, a global cache like ccache can speed up compilations significantly.</p>
<p>ccache can be used by setting up symbolic links to compiler executables (such as <code>g++</code>, <code>gcc</code>) in the file system. In this setup, the use of ccache is transparent to Qbs. If you prefer to call ccache explicitly, you should set <a href="qml-qbsmodules-cpp.html#compilerWrapper-prop">cpp.compilerWrapper</a> to <code>ccache</code>.</p>
<p><b>Note: </b>Using precompiled headers might prevent ccache from actually using cached results. To work around this, you can set <code>sloppiness=pch_defines,time_macros</code> in your local ccache options. See the <a href="https://ccache.samba.org/manual.html#_precompiled_headers">ccache documentation about precompiled headers</a> for further details.</p><a name="how-do-i-create-a-module-for-a-third-party-library"></a>
<h2 id="how-do-i-create-a-module-for-a-third-party-library">How do I create a module for a third-party library?</h2>
<p>If you have pre-built binary files in your source tree, you can create modules for them and then introduce dependencies between your project and the modules to pull in the functionality of a third-party library.</p>
<p>Create the following folder structure to store the module files:</p>
<pre class="cpp">

  $projectroot<span class="operator">/</span>modules<span class="operator">/</span>ThirdParty

</pre>
<p>Then create a file in the directory that specifies the module properties for each supported toolchain. The filename must have the <code>.qbs</code> extension. The module will be pulled in if a product declares a dependency on it.</p>
<p>In the following example, <code>lib1.dylib</code> is a multi-architecture library containing both 32-bit and 64-bit code.</p>
<pre class="cpp">

  <span class="operator">-</span><span class="operator">-</span><span class="operator">-</span>ThirdParty<span class="operator">.</span>qbs<span class="operator">-</span><span class="operator">-</span><span class="operator">-</span>

  Module {
      Depends { name: <span class="string">&quot;cpp&quot;</span> }
      cpp<span class="operator">.</span>includePaths: <span class="operator">[</span><span class="string">&quot;/somewhere/include&quot;</span><span class="operator">]</span>
      Properties {
          condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;android&quot;</span>)
          cpp<span class="operator">.</span>dynamicLibraries: <span class="operator">[</span><span class="string">&quot;/somewhere/android/&quot;</span> <span class="operator">+</span> Android<span class="operator">.</span>ndk<span class="operator">.</span>abi <span class="operator">+</span> <span class="string">&quot;/lib1.so&quot;</span><span class="operator">]</span>
      }
      Properties {
          condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;macos&quot;</span>)
          cpp<span class="operator">.</span>dynamicLibraries: <span class="operator">[</span><span class="string">&quot;/somewhere/macos/lib1.dylib&quot;</span><span class="operator">]</span>
      }
      Properties {
          condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;windows&quot;</span>) <span class="operator">&amp;</span><span class="operator">&amp;</span> qbs<span class="operator">.</span>architecture <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;x86&quot;</span>
          cpp<span class="operator">.</span>dynamicLibraries: <span class="operator">[</span><span class="string">&quot;/somewhere/windows_x86/lib1.lib&quot;</span><span class="operator">]</span>
      }
      Properties {
          condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;windows&quot;</span>) <span class="operator">&amp;</span><span class="operator">&amp;</span> qbs<span class="operator">.</span>architecture <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;x86_64&quot;</span>
          cpp<span class="operator">.</span>dynamicLibraries: <span class="operator">[</span><span class="string">&quot;/somewhere/windows_x86_64/lib1.lib&quot;</span><span class="operator">]</span>
      }
  }

</pre>
<p>Finally, declare dependencies on <code>ThirdParty</code> in your project:</p>
<pre class="cpp">

  CppApplication {
      name: <span class="string">&quot;the-app&quot;</span>
      files: <span class="operator">[</span><span class="string">&quot;main.cpp&quot;</span><span class="operator">]</span>
      Depends { name: <span class="string">&quot;ThirdParty&quot;</span> }
  }

</pre>
<a name="how-do-i-create-application-bundles-and-frameworks-on-ios-macos-tvos-and-watchos"></a>
<h2 id="how-do-i-create-application-bundles-and-frameworks-on-ios-macos-tvos-and-watchos">How do I create application bundles and frameworks on iOS, macOS, tvOS, and watchOS?</h2>
<p>Creating an application bundle or framework is achieved by introducing a dependency on the <a href="qml-qbsmodules-bundle.html">bundle</a> module and setting the <a href="qml-qbsmodules-bundle.html#isBundle-prop">bundle.isBundle</a> property to <code>true</code>.</p>
<p>Here is a simple example for an application:</p>
<pre class="cpp">

  Application {
      Depends { name: <span class="string">&quot;cpp&quot;</span> }
      Depends { name: <span class="string">&quot;bundle&quot;</span> }
      bundle<span class="operator">.</span>isBundle: <span class="keyword">true</span>
      name: <span class="string">&quot;the-app&quot;</span>
      files: <span class="operator">[</span><span class="string">&quot;main.cpp&quot;</span><span class="operator">]</span>
  }

</pre>
<p>and for a framework:</p>
<pre class="cpp">

  DynamicLibrary {
      Depends { name: <span class="string">&quot;cpp&quot;</span> }
      Depends { name: <span class="string">&quot;bundle&quot;</span> }
      bundle<span class="operator">.</span>isBundle: <span class="keyword">true</span>
      name: <span class="string">&quot;the-lib&quot;</span>
      files: <span class="operator">[</span><span class="string">&quot;lib.cpp&quot;</span><span class="operator">,</span> <span class="string">&quot;lib.h&quot;</span><span class="operator">]</span>
  }

</pre>
<p>Qbs also supports building static frameworks. You can create one by replacing the <a href="qml-qbsconvenienceitems-dynamiclibrary.html">DynamicLibrary</a> item with a <a href="qml-qbsconvenienceitems-staticlibrary.html">StaticLibrary</a> item in the example above.</p>
<p><b>Note: </b>When using the <a href="qml-qbsconvenienceitems-application.html">Application</a> item (or convenience items, such as <a href="qml-qbsconvenienceitems-cppapplication.html">CppApplication</a>, <a href="qml-qbsconvenienceitems-dynamiclibrary.html">DynamicLibrary</a>, and <a href="qml-qbsconvenienceitems-staticlibrary.html">StaticLibrary</a>), your products will be built as bundles on Apple platforms by default (this behavior is subject to change in a future release).</p><p>To explicitly control whether your product is built as a bundle, set the <code>bundle.isBundle</code> property. Setting the <a href="qml-qbslanguageitems-product.html#consoleApplication-prop">consoleApplication</a> property of your product will also influence whether your product is built as a bundle.</p>
<p>Building your application against your framework is the same as linking a normal dynamic or static library; see the <a href="howtos.html#how-do-i-make-my-app-build-against-my-library">How do I make my app build against my library?</a> section for an example.</p>
<a name="how-do-i-build-against-libraries-that-provide-pkg-config-files"></a>
<h2 id="how-do-i-build-against-libraries-that-provide-pkg-config-files">How do I build against libraries that provide pkg-config files?</h2>
<p>Just add a <a href="qml-qbslanguageitems-depends.html">Depends</a> item that matches the name of the pkg-config module, and Qbs will automatically employ <a href="https://www.freedesktop.org/wiki/Software/pkg-config">pkg-config</a> to find the headers and libraries if no matching Qbs module can be found. For instance, to build against the OpenSSL library, you would write this:</p>
<pre class="cpp">

  Depends { name: <span class="string">&quot;openssl&quot;</span> }

</pre>
<p>That's it. The pkg-config behavior can be fine-tuned via the <a href="qml-qbsmodules-pkgconfig.html">pkgconfig</a> module, but normally you will not need to pull it in explicitly.</p>
<p>Internally, this functionality is implemented via <a href="module-providers.html">Module Providers</a></p>
<a name="how-do-i-apply-c-c-preprocessor-macros-to-only-a-subset-of-the-files-in-my-product"></a>
<h2 id="how-do-i-apply-c-c-preprocessor-macros-to-only-a-subset-of-the-files-in-my-product">How do I apply C/C++ preprocessor macros to only a subset of the files in my product?</h2>
<p>Use a <a href="qml-qbslanguageitems-group.html">Group</a> item to define a subset of project files. To add macros within the group, you need to use the <code>outer.concat</code> property, because you are adding macros to those specified in the outer scope.</p>
<p>In the following example, <code>MACRO_EVERYWHERE</code> is defined for all files in the <a href="qml-qbslanguageitems-product.html">Product</a> unless a Group overrides the macro, whereas <code>MACRO_GROUP</code> is only defined for <code>groupFile.cpp</code>.</p>
<pre class="cpp">

  Product {
      Depends { name: <span class="string">&quot;cpp&quot;</span> }
      cpp<span class="operator">.</span>defines: <span class="operator">[</span><span class="string">&quot;MACRO_EVERYWHERE&quot;</span><span class="operator">]</span>
      Group {
          cpp<span class="operator">.</span>defines: outer<span class="operator">.</span>concat(<span class="string">&quot;MACRO_GROUP&quot;</span>)
          files: <span class="string">&quot;groupFile.cpp&quot;</span>
      }
  }

</pre>
<p>The <code>cpp.defines</code> statements inside a <code>Group</code> only apply to the files in that <code>Group</code>, and therefore you cannot use a <code>Group</code> to include a bunch of files and globally visible macros. The macros must be specified in a <a href="commands.html#properties">Properties</a> item at the same level as the <code>Group</code> if they need to be visible to files outside the <code>Group</code>:</p>
<pre class="cpp">

  Product {
      Depends { name: <span class="string">&quot;cpp&quot;</span> }
      Group {
          condition: project<span class="operator">.</span>supportMyFeature
          files: <span class="string">&quot;myFile.cpp&quot;</span>
      }

      property stringList commonDefines: <span class="operator">[</span><span class="string">&quot;ONE&quot;</span><span class="operator">,</span> <span class="string">&quot;TWO&quot;</span><span class="operator">]</span>

      Properties {
          condition: project<span class="operator">.</span>supportMyFeature
          cpp<span class="operator">.</span>defines: commonDefines<span class="operator">.</span>concat(<span class="string">&quot;MYFEATURE_SUPPORTED&quot;</span>)
      }
  }

</pre>
<a name="how-do-i-make-the-state-of-my-git-repository-available-to-my-source-files"></a>
<h2 id="how-do-i-make-the-state-of-my-git-repository-available-to-my-source-files">How do I make the state of my Git repository available to my source files?</h2>
<p>Add a dependency to the <a href="qml-qbsmodules-vcs.html">vcs</a> module to your product:</p>
<pre class="cpp">

  CppApplication {
      <span class="comment">// ...</span>
      Depends { name: <span class="string">&quot;vcs&quot;</span> }
      <span class="comment">// ...</span>
  }

</pre>
<p>Your source files will now have access to a macro whose value is a string representing the current Git or Subversion HEAD:</p>
<pre class="cpp">

  <span class="preprocessor">#include &lt;vcs-repo-state.h&gt;</span>
  <span class="preprocessor">#include &lt;iostream&gt;</span>

  <span class="type">int</span> main()
  {
      std<span class="operator">::</span>cout <span class="operator">&lt;</span><span class="operator">&lt;</span> <span class="string">&quot;I was built from &quot;</span> <span class="operator">&lt;</span><span class="operator">&lt;</span> VCS_REPO_STATE <span class="operator">&lt;</span><span class="operator">&lt;</span> std<span class="operator">::</span>endl;
  }

</pre>
<p>This value is also available via the <a href="qml-qbsmodules-vcs.html#repoState-prop">vcs.repoState</a> property.</p>
<a name="how-do-i-limit-the-number-of-concurrent-jobs-for-the-linker-only"></a>
<h2 id="how-do-i-limit-the-number-of-concurrent-jobs-for-the-linker-only">How do I limit the number of concurrent jobs for the linker only?</h2>
<a name="job-pool-howto"></a><p>While it is usually desirable to run as many compiler jobs as there are CPU cores, the same is not true for linker jobs. The reason is that linkers are typically I/O bound rather than CPU bound. When building large libraries, they also tend to use up enormous amounts of memory. Therefore, we'd like to make sure that only a few linkers are running at the same time without limiting other types of jobs. In Qbs, this is achieved via <i>job pools</i>. There are several ways to make use of them.</p>
<p>Firstly, you can provide a limit via the command line:</p>
<pre class="cpp">

  $ qbs <span class="operator">-</span><span class="operator">-</span>job<span class="operator">-</span>limits linker:<span class="number">4</span>

</pre>
<p>The above call instructs Qbs to run at most four linker instances at the same time, while leaving the general number of concurrent jobs at the default value, which is derived from the number of CPU cores. The <code>linker</code> string on the command line refers to the job pool of the same name, which the <a href="qml-qbsmodules-cpp.html#cpp-job-pools">cpp module</a> assigns to all its commands that invoke a linker.</p>
<p>Secondly, you can set a limit via the settings, either generally or for a specific profile:</p>
<pre class="cpp">

  $ qbs config preferences<span class="operator">.</span>jobLimit<span class="operator">.</span>linker <span class="number">4</span>
  $ qbs config profiles<span class="operator">.</span>myprofile<span class="operator">.</span>preferences<span class="operator">.</span>jobLimit<span class="operator">.</span>linker <span class="number">2</span>

</pre>
<p>And finally, you can also set the limit per project or per product, using a <a href="qml-qbslanguageitems-joblimit.html">JobLimit</a> item:</p>
<pre class="cpp">

  Product {
      name: <span class="string">&quot;my_huge_library&quot;</span>
      JobLimit {
          jobPool: <span class="string">&quot;linker&quot;</span>
          jobCount: <span class="number">1</span>
      }
      <span class="comment">// ...</span>
  }

</pre>
<p>The above construct ensures that this specific library is never linked at the same time as any other binary in the project.</p>
<p>Job limits set on the command line override those from the settings, which in turn override the ones defined within a project. Use the <code>--enforce-project-job-limits</code> option to give the job limits defined via <code>JobLimit</code> items maximum precedence.</p>
<a name="how-do-i-add-qml-files-to-a-project"></a>
<h2 id="how-do-i-add-qml-files-to-a-project">How do I add QML files to a project?</h2>
<p>The simplest way to add QML files to a project is to add them to a resource file:</p>
<pre class="cpp">

  <span class="type"><a href="qml-qbsconvenienceitems-qtguiapplication.html">QtGuiApplication</a></span> {
      <span class="comment">// ...</span>

      files: <span class="string">&quot;main.cpp&quot;</span>

      Group {
          prefix: <span class="string">&quot;qml/&quot;</span>
          files: <span class="operator">[</span><span class="string">&quot;main.qml&quot;</span><span class="operator">,</span> <span class="string">&quot;HomePage.qml&quot;</span><span class="operator">]</span>
          fileTags: <span class="operator">[</span><span class="string">&quot;qt.qml.qml&quot;</span><span class="operator">,</span> <span class="string">&quot;qt.core.resource_data&quot;</span><span class="operator">]</span>
      }
  }

</pre>
<p>In the example above, we declare each QML file as having the <a href="qml-qbsmodules-qt-core.html#filetags-qtcore">&quot;qt.core.resource_data&quot;</a> file tag. This ensures that it is added to a generated resource file.</p>
</div>
<!-- @@@howtos.html -->
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="custom-modules.html">Custom Modules and Items</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="reference.html">Reference</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
